s3: Fix a likely cut&paste error
[Samba/gebeck_regimport.git] / pidl / wscript
blobe60ca202f501d965e3c00d0004ef50546b024712
1 #!/usr/bin/env python
3 import os, sys, Logs
4 from samba_utils import MODE_755
6 def set_options(opt):
7 opt.tool_options('perl')
9 def configure(conf):
10 conf.check_tool('perl')
11 # we need a recent version of MakeMaker to get the right man page names
12 if conf.CHECK_PERL_MANPAGE():
13 conf.env.PERLMAN1EXT = conf.CHECK_PERL_MANPAGE(section='1')
14 conf.env.PERLMAN3EXT = conf.CHECK_PERL_MANPAGE(section='3')
15 conf.DEFINE('HAVE_PERL_MAKEMAKER', 1)
17 # yapp is used for building the parser
18 conf.find_program('yapp', var='YAPP')
19 conf.find_program('pod2man', var='POD2MAN')
21 def build(bld):
22 bld.INSTALL_FILES('${BINDIR}', 'pidl', chmod=MODE_755)
24 bld.RECURSE('lib')
26 if not bld.CONFIG_SET('HAVE_PERL_MAKEMAKER'):
27 return
29 pidl_src = ['pidl']
30 pidl_src.extend(bld.path.ant_glob('lib/**/*.pm').split())
32 pidl_manpages = {
33 'pidl': 'man1/pidl.${PERLMAN1EXT}',
34 'lib/Parse/Pidl/NDR.pm': 'man3/Parse::Pidl::NDR.${PERLMAN3EXT}',
35 'lib/Parse/Pidl/Wireshark/Conformance.pm': 'man3/Parse::Pidl::Wireshark::Conformance.${PERLMAN3EXT}',
36 'lib/Parse/Pidl/Dump.pm': 'man3/Parse::Pidl::Dump.${PERLMAN3EXT}',
37 'lib/Parse/Pidl/Util.pm': 'man3/Parse::Pidl::Util.${PERLMAN3EXT}',
38 'lib/Parse/Pidl/Wireshark/NDR.pm': 'man3/Parse::Pidl::Wireshark::NDR.${PERLMAN3EXT}'
41 for k, v in pidl_manpages.iteritems():
42 pidl_manpages[k] = bld.EXPAND_VARIABLES(v)
44 # use perl to build the manpages
45 bld.env.pidl_srcdir = os.path.join(bld.srcnode.abspath(), 'pidl')
47 blib_bld = os.path.join(bld.srcnode.abspath(bld.env), 'pidl/blib')
49 bld.SET_BUILD_GROUP('final')
50 if 'POD2MAN' in bld.env and bld.env['POD2MAN'] != '':
51 for src, manpage in pidl_manpages.iteritems():
52 bld(rule='${PERL} ${POD2MAN} -c "Samba Documentation" ${SRC} ${TGT}',
53 shell=True,
54 source=src,
55 install_path=os.path.dirname(bld.EXPAND_VARIABLES('${MANDIR}/'+manpage)),
56 target=os.path.basename(manpage))
58 # we want to prefer the git version of the parsers if we can.
59 # Only if the source has changed do we want to re-run yapp
60 # But we force the developer to use the pidl standalone build
61 # to regenerate the files.
62 # TODO: only warn in developer mode and if 'git diff HEAD'
63 # shows a difference
64 warn_about_grammar_changes = ('PIDL_BUILD_WARNINGS' in bld.env and (
65 bld.IS_NEWER('idl.yp', 'lib/Parse/Pidl/IDL.pm') or
66 bld.IS_NEWER('expr.yp', 'lib/Parse/Pidl/Expr.pm')))
68 if warn_about_grammar_changes:
69 Logs.warn('''
70 Pidl grammar files have changed. Please use the pidl standalone build
71 to regenerate them with yapp.
73 $ cd ../pidl
74 $ perl Makefile.PL
75 $ make lib/Parse/Pidl/IDL.pm lib/Parse/Pidl/Expr.pm
76 $ git add lib/Parse/Pidl/IDL.pm lib/Parse/Pidl/Expr.pm
77 $ git commit
78 $ cd -
80 If your 100% sure you haven't changed idl.yp and expr.yp
81 try this to avoid this message:
83 $ touch ../pidl/lib/Parse/Pidl/IDL.pm ../pidl/lib/Parse/Pidl/Expr.pm
84 ''')